﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace LaPucelleToolpack
{
	public class Dictionary
	{
		public List<string> words_jpn;
		public List<string> words_eng;

		public Dictionary()
		{
			words_jpn = new List<string>();
			words_eng = new List<string>();

			this.JASCII = "　ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰＱＲＳＴＵＶＷＸＹＺ０１２３４５６７８９ー？！（）．，";
			this.ASCII = " abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-?!().,";

			FillWordList();
		}

		private void FillWordList()
		{
			// other names

			// character names

			//normal words
			words_jpn.Add("ねぇ"); words_eng.Add("Hey");
			words_jpn.Add("ねえ"); words_eng.Add("Hey");
			
			/*
			words.Add(""); translation.Add("");
			words.Add(""); translation.Add("");
			words.Add(""); translation.Add("");
			words.Add(""); translation.Add("");
			words.Add(""); translation.Add("");
			words.Add(""); translation.Add("");
			*/
		}

		public void LoadExternalDict(string sPath, bool bClear = false)
		{
			if (File.Exists(sPath))
			{
				if (bClear)
				{
					this.words_jpn = new List<string>();
					this.words_eng = new List<string>();
				}

				string line;
				string[] words;

				using (StreamReader sr = new StreamReader(File.OpenRead(sPath), Encoding.UTF8))
				{
					while (sr.Peek() > -1)
					{
						line = sr.ReadLine();
						words = line.Split(new char[] { ';' });

						this.words_jpn.Add(words[0]);
						this.words_eng.Add(words[1]);
					}
				}
			}
		}

		public string TranslateJPN2ENG(string input)
		{
			string text = input;

			for (int i = 0; i < this.words_jpn.Count; i++)
			{
				text = text.Replace(this.words_jpn[i], this.words_eng[i]);
			}

			return JASCII2ASCII(text);
		}

		public string TranslateENG2JPN(string input)
		{
			string text = input;

			for (int i = 0; i < this.words_jpn.Count; i++)
			{
				text = text.Replace(this.words_eng[i], this.words_jpn[i]);
			}

			return ASCII2JASCII(text);
		}

		public string JASCII2ASCII(string input)
		{
			string text = input;

			for (int i = 0; i < this.JASCII.Length; i++)
			{
				text = text.Replace(this.JASCII[i], this.ASCII[i]);
			}

			return text;
		}

		public string ASCII2JASCII(string input)
		{
			string text = input;

			for (int i = 0; i < this.ASCII.Length; i++)
			{
				text = text.Replace(this.ASCII[i], this.JASCII[i]);
			}

			text = text.Replace("．．．", "…");
			text = text.Replace("...", "…");

			return text;
		}

		public string JASCII { get; set; }
		public string ASCII { get; set; }
	}
}
