﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LaPucelleToolpack
{
	public class FNT
	{
		public List<ushort> entries;
		public string[] letters;

		Tools tools;
		public FNT(Tools tool)
		{
			tools = tool;
			numEntries = 0;
			entries = new List<ushort>();
		}

		public int LoadFNT(string sPath)
		{
			if (File.Exists(sPath))
			{
				using (BinaryReader br = new BinaryReader(File.OpenRead(sPath)))
				{
					this.numEntries = br.ReadUInt16();
					this.letters = new string[this.numEntries];

					for (int i = 0; i < this.numEntries; i++)
					{
						if (i < 126) // ASCII
							this.letters[i] = ((char)(0x20 + i)).ToString();
						else if(i == 275)
							this.letters[i] = "♪";
						else if (i == 276)
							this.letters[i] = "†";
						else if (i >= 302 && i <= 311) //JASCII 0-9
							this.letters[i] = ((char)(0xFDE2 + i)).ToString();
						else if (i >= 319 && i <= 344) //JASCII A-Z
							this.letters[i] = ((char)(0xFDE2 + i)).ToString();
						else if (i >= 352 && i <= 377) //JASCII A-Z
							this.letters[i] = ((char)(0xFDE1 + i)).ToString();


						entries.Add(br.ReadUInt16());
					}
				}
				return 0;
			}
			return -1;
		}

		public int SaveFNT(string sPath)
		{
			try
			{
				tools.DeleteFileIfExists(sPath);
				using (BinaryWriter bw = new BinaryWriter(File.OpenWrite(sPath)))
				{
					bw.Write(this.numEntries);

					for (int i = 0; i < this.numEntries; i++)
					{
						bw.Write(entries[i]);
					}

				}
			}
			catch
			{
				return -1;
			}
			return 0;
		}

		public ushort numEntries { get; set; }
	}
}
